Index: /orxonox/trunk/src/lib/coord/null_parent.cc
===================================================================
--- /orxonox/trunk/src/lib/coord/null_parent.cc	(revision 3544)
+++ /orxonox/trunk/src/lib/coord/null_parent.cc	(revision 3545)
@@ -74,4 +74,6 @@
 void NullParent::update (float timeStamp)
 {
+
+  printf ("NullParent::update - (%f, %f, %f)\n", this->absCoordinate.x, this->absCoordinate.y, this->absCoordinate.z);
   this->absCoordinate = this->relCoordinate;
   this->absDirection = parent->getAbsDir () * this->relDirection;
Index: /orxonox/trunk/src/lib/coord/p_node.cc
===================================================================
--- /orxonox/trunk/src/lib/coord/p_node.cc	(revision 3544)
+++ /orxonox/trunk/src/lib/coord/p_node.cc	(revision 3545)
@@ -42,9 +42,8 @@
   this->bAbsDirChanged = false;
   this->parent = NULL;
-
-  printf("PNode::PNode() - constructor, now adding\n");
+  this->objectName = NULL;
+
   NullParent* np = NullParent::getInstance();
   np->addChild(this);
-  printf("PNode::PNode() - finished adding\n");
 }
 
@@ -66,4 +65,5 @@
   this->bAbsDirChanged = false;
   this->parent = parent;
+  this->objectName = NULL;
 
   parent->addChild (this);
@@ -86,5 +86,4 @@
 PNode::PNode(char* name)
 {
-  printf("PNode::PNode(char*) - start\n");
   this->children = new tList<PNode>();
   this->bRelCoorChanged = true;
@@ -93,5 +92,5 @@
   this->bAbsDirChanged = false;
   this->parent = NULL; 
-  printf("PNode::PNode(char*) - end\n");
+  this->objectName = NULL;
 }
 
@@ -355,5 +354,5 @@
 
   */
-
+  //pNode->remove();
   this->children->remove (pNode);
   pNode->parent = NULL;
@@ -442,5 +441,5 @@
 void PNode::update (float timeStamp)
 {
-  //printf ("PNode::update - %s - (%f, %f, %f)\n", this->objectName, this->absCoordinate.x, this->absCoordinate.y, this->absCoordinate.z);
+  printf ("PNode::update - %s - (%f, %f, %f)\n", this->objectName, this->absCoordinate.x, this->absCoordinate.y, this->absCoordinate.z);
   // printf("%s", this->objectName);
 
@@ -449,5 +448,4 @@
 	  if( this->bAbsCoorChanged /*&& this->timeStamp != DataTank::timeStamp*/)
 	    {
-	      printf("PNode::update () - this->bAbsCoorChanged = true\n");
 	      /* if you have set the absolute coordinates this overrides all other changes */
 	      this->relCoordinate = this->absCoordinate - parent->getAbsCoor ();
@@ -483,5 +481,4 @@
 	  if( this->bAbsCoorChanged /*&& this->timeStamp != DataTank::timeStamp*/)
 	    {
-	      printf("PNode::update () - this->bAbsCoorChanged = true\n");
 	      /* if you have set the absolute coordinates this overrides all other changes */
 	      this->relCoordinate = this->absCoordinate - parent->getAbsCoor ();
Index: /orxonox/trunk/src/story_entities/world.cc
===================================================================
--- /orxonox/trunk/src/story_entities/world.cc	(revision 3544)
+++ /orxonox/trunk/src/story_entities/world.cc	(revision 3545)
@@ -222,5 +222,6 @@
 
 	    // Create SkySphere
-	    skySphere = new Skysphere("../data/pictures/sky-replace.jpg");
+	    this->skySphere = new Skysphere("../data/pictures/sky-replace.jpg");
+	    this->skySphere->setName("SkySphere");
 	    this->localCamera->addChild(this->skySphere);
 	    this->skySphere->setMode(MOVEMENT);
@@ -249,10 +250,4 @@
 	    TrackNode* tn = TrackNode::getInstance();
 	    tn->addChild(myPlayer);
-
-	    //Vector v(1.0, 0.0, 0.0);
-	    //Quaternion* q = new Quaternion(90.0, v);
-	    //this->relDirection = this->relDirection * q;
-	    
-	    //tn->setAbsDir(q);
 
 	    //localCamera->setParent(TrackNode::getInstance());
@@ -694,4 +689,5 @@
   while( !this->bQuitOrxonox && !this->bQuitCurrentGame) /* \todo implement pause */
     {
+      printf("World::mainloop() - number of entities: %i\n", this->entities->getSize());
       // Network
       this->synchronize ();
Index: /orxonox/trunk/src/track_node.cc
===================================================================
--- /orxonox/trunk/src/track_node.cc	(revision 3544)
+++ /orxonox/trunk/src/track_node.cc	(revision 3545)
@@ -42,4 +42,5 @@
 {
   this->setClassName("TrackNode");
+  this->setName("TrackNode"); /* absolete but still used... */
   singletonRef = this;
 