Index: /orxonox/trunk/src/lib/coord/p_node.cc
===================================================================
--- /orxonox/trunk/src/lib/coord/p_node.cc	(revision 3545)
+++ /orxonox/trunk/src/lib/coord/p_node.cc	(revision 3546)
@@ -327,5 +327,4 @@
   if( pNode->parent != NULL )
     {
-      printf("PNode::addChild() - removing child from old parent \n");
       PRINTF(2)("PNode::addChild() - reparenting node: removing it and adding it again\n");
       pNode->parent->removeChild(pNode);
@@ -334,5 +333,4 @@
   pNode->parent = this;
   this->children->add(pNode);
-  printf("PNode::addChild() - Parent added\n");
 }
 
@@ -441,5 +439,5 @@
 void PNode::update (float timeStamp)
 {
-  printf ("PNode::update - %s - (%f, %f, %f)\n", this->objectName, this->absCoordinate.x, this->absCoordinate.y, this->absCoordinate.z);
+  PRINTF(2)("PNode::update - %s - (%f, %f, %f)\n", this->objectName, this->absCoordinate.x, this->absCoordinate.y, this->absCoordinate.z);
   // printf("%s", this->objectName);
 
@@ -541,5 +539,5 @@
 void PNode::debug()
 {
-  printf("PNode::debug() - absCoord: (%f, %f, %f)\n", 
+  PRINTF(2)("PNode::debug() - absCoord: (%f, %f, %f)\n", 
 	 this->absCoordinate.x, 
 	 this->absCoordinate.y,
Index: /orxonox/trunk/src/orxonox.cc
===================================================================
--- /orxonox/trunk/src/orxonox.cc	(revision 3545)
+++ /orxonox/trunk/src/orxonox.cc	(revision 3546)
@@ -31,5 +31,5 @@
 #include "game_loader.h"
 #include <string.h>
-int verbose;
+int verbose = 2;
 
 using namespace std;
Index: /orxonox/trunk/src/story_entities/world.cc
===================================================================
--- /orxonox/trunk/src/story_entities/world.cc	(revision 3545)
+++ /orxonox/trunk/src/story_entities/world.cc	(revision 3546)
@@ -43,5 +43,4 @@
 {
   this->init(name, -1);
-  printf("World::World - generating Nullparent\n");
   NullParent* np = NullParent::getInstance();
 }
@@ -64,5 +63,5 @@
 World::~World ()
 {
-  printf("World::~World() - deleting current world\n");
+  PRINTF(3)("World::~World() - deleting current world\n");
   CommandNode* cn = Orxonox::getInstance()->getLocalInput();
   cn->unbind(this->localPlayer);
@@ -469,5 +468,5 @@
 ErrorMessage World::start()
 {
-  printf("World::start() - starting current World: nr %i\n", this->debugWorldNr);
+  PRINTF(3)("World::start() - starting current World: nr %i\n", this->debugWorldNr);
   this->bQuitOrxonox = false;
   this->bQuitCurrentGame = false;
@@ -482,5 +481,5 @@
 ErrorMessage World::stop()
 {
-  printf("World::stop() - got stop signal\n");
+  PRINTF(3)("World::stop() - got stop signal\n");
   this->bQuitCurrentGame = true;
 }
@@ -515,5 +514,5 @@
 void World::displayLoadScreen ()
 {
-  printf ("World::displayLoadScreen - start\n"); 
+  PRINTF(3)("World::displayLoadScreen - start\n"); 
   
   //GLMenuImageScreen* 
@@ -523,5 +522,5 @@
   this->glmis->draw();
  
-  printf ("World::displayLoadScreen - end\n"); 
+  PRINTF(3)("World::displayLoadScreen - end\n"); 
 }
 
@@ -533,8 +532,8 @@
 void World::releaseLoadScreen ()
 {
-  printf ("World::releaseLoadScreen - start\n"); 
+  PRINTF(3)("World::releaseLoadScreen - start\n"); 
   this->glmis->setValue(this->glmis->getMaximum());
   SDL_Delay(500);
-  printf ("World::releaseLoadScreen - end\n"); 
+  PRINTF(3)("World::releaseLoadScreen - end\n"); 
 }
 
@@ -614,5 +613,5 @@
 void World::debug()
 {
-  printf ("World::debug() - starting debug\n");
+  PRINTF(2)("debug() - starting debug\n");
   PNode* p1 = NullParent::getInstance ();
   PNode* p2 = new PNode (new Vector(2, 2, 2), p1);
@@ -686,8 +685,8 @@
 {
   this->lastFrame = SDL_GetTicks ();
-  printf("World::mainLoop() - Entering main loop\n");
+  PRINTF(3)("World::mainLoop() - Entering main loop\n");
   while( !this->bQuitOrxonox && !this->bQuitCurrentGame) /* \todo implement pause */
     {
-      printf("World::mainloop() - number of entities: %i\n", this->entities->getSize());
+      PRINTF(3)("World::mainloop() - number of entities: %i\n", this->entities->getSize());
       // Network
       this->synchronize ();
@@ -695,8 +694,5 @@
       this->handleInput ();
       if( this->bQuitCurrentGame || this->bQuitOrxonox)
-	{
-	  printf("World::mainLoop() - leaving loop earlier...\n");
 	  break;
-	}
       // Process time
       this->timeSlice ();
@@ -709,5 +705,5 @@
       /* \todo this is to slow down the program for openGl Software emulator computers, reimplement*/
     }
-  printf("World::mainLoop() - Exiting the main loop\n");
+  PRINTF(3)("World::mainLoop() - Exiting the main loop\n");
 }
 
@@ -755,5 +751,5 @@
 	{
 	  float fps = 1000/dt;
-	  printf("fps = %f\n", fps);
+	  PRINTF(3)("fps = %f\n", fps);
 	}
       else
@@ -762,5 +758,5 @@
 	     nothing.
 	  */
-	  printf("fps = 1000 - frame rate is adjusted\n");
+	  PRINTF(2)("fps = 1000 - frame rate is adjusted\n");
 	  SDL_Delay(10);
 	  dt = 10;
@@ -771,5 +767,4 @@
       WorldEntity* entity;
       float seconds = dt / 1000.0;      
-      this->nullParent->update (seconds);
       entity = entities->enumerate(); 
       while( entity != NULL) 
@@ -783,4 +778,5 @@
       this->localCamera->timeSlice(dt);
       this->trackManager->tick(dt);
+      this->nullParent->update (seconds);
     }
   this->lastFrame = currentFrame;
Index: /orxonox/trunk/src/track_manager.cc
===================================================================
--- /orxonox/trunk/src/track_manager.cc	(revision 3545)
+++ /orxonox/trunk/src/track_manager.cc	(revision 3546)
@@ -664,5 +664,4 @@
       Vector v(0.0, 1.0, 0.0);
       Quaternion q(-PI/2, v);
-      //this->relDirection = this->relDirection * q;
       quat = quat * q;
 