Index: /orxonox/trunk/src/defs/debug.h
===================================================================
--- /orxonox/trunk/src/defs/debug.h	(revision 3547)
+++ /orxonox/trunk/src/defs/debug.h	(revision 3548)
@@ -27,4 +27,5 @@
 #define INFO            3
 #define DEBUGING        4
+#define vDEBUGING       5
 
 #if HAVE_CONFIG_H 
@@ -76,5 +77,12 @@
 #endif
      
-     
+#if DEBUG >= vDEBUGING
+#define PRINTF5 \
+     if (verbose >= vDEBUGING) \
+       printf("VERYDEBUG::%s:%d:", __FILE__, __LINE__) && printf
+#else 
+#define PRINTF5 if (NO)
+#endif
+    
 #else  
 #define PRINTF(x) if (NO)
@@ -124,4 +132,12 @@
 #else 
 #define PRINT4 if (NO)
+#endif
+
+#if DEBUG >= vDEBUGING
+#define PRINT5 \
+     if (verbose >= vDEBUGING) \
+       printf("VERYDEBUG::%s:%d:", __FILE__, __LINE__) && printf
+#else 
+#define PRINT5 if (NO)
 #endif
 
Index: /orxonox/trunk/src/lib/graphics/font/fontset.cc
===================================================================
--- /orxonox/trunk/src/lib/graphics/font/fontset.cc	(revision 3547)
+++ /orxonox/trunk/src/lib/graphics/font/fontset.cc	(revision 3548)
@@ -45,5 +45,6 @@
 #include <stdarg.h>
 
-#include "../importer/texture.h"
+#include "texture.h"
+#include <string.h>
 
 /** 
Index: /orxonox/trunk/src/lib/graphics/importer/array.cc
===================================================================
--- /orxonox/trunk/src/lib/graphics/importer/array.cc	(revision 3547)
+++ /orxonox/trunk/src/lib/graphics/importer/array.cc	(revision 3548)
@@ -30,5 +30,5 @@
 Array::~Array()
 {
-  PRINTF(2)("deleting array\n");
+  PRINTF(4)("deleting array\n");
   Entry* walker = this->firstEntry;
   Entry* previous;
@@ -49,5 +49,5 @@
 void Array::initializeArray ()
 {
-  PRINTF(2)("crating new Array\n");
+  PRINTF(4)("crating new Array\n");
   this->firstEntry = new Entry;
   this->firstEntry->next =NULL;
@@ -64,5 +64,5 @@
 void Array::finalizeArray (void)
 {
-  PRINTF(3)("Finalizing array. Length: %i\n", entryCount);  
+  PRINTF(4)("Finalizing array. Length: %i\n", entryCount);  
   //  if ((array = (GLfloat*)malloc( entryCount* sizeof(GLfloat))) == NULL)
   if (!(this->array = new GLfloat [this->entryCount]))
@@ -87,5 +87,5 @@
   if (!this->finalized)
     {
-      PRINTF(3)("adding new Entry to Array: %f\n", entry);
+      PRINTF(5)("adding new Entry to Array: %f\n", entry);
       
       this->currentEntry->value = entry;
@@ -96,5 +96,5 @@
     }
   else 
-    PRINTF(1)("adding failed, because list has been finalized\n");
+    PRINTF(2)("adding failed, because list has been finalized\n");
 }
 
@@ -131,4 +131,4 @@
 void Array::debug ()
 {
-  PRINTF(0)("entryCount=%i, address=%p\n", this->entryCount, this->array);
+  PRINT(0)("entryCount=%i, address=%p\n", this->entryCount, this->array);
 }
Index: /orxonox/trunk/src/lib/graphics/importer/material.cc
===================================================================
--- /orxonox/trunk/src/lib/graphics/importer/material.cc	(revision 3547)
+++ /orxonox/trunk/src/lib/graphics/importer/material.cc	(revision 3548)
@@ -18,4 +18,5 @@
 
 #include "texture.h"
+#include "debug.h"
 #include <stdlib.h>
 #include <string.h>
@@ -51,5 +52,5 @@
 Material::~Material()
 {
-  PRINTF(2)("delete Material %s.\n", this->name);
+  PRINTF(4)("delete Material %s.\n", this->name);
   if (this->name)
     delete []this->name;
@@ -83,5 +84,5 @@
 void Material::init(void)
 {
-  PRINTF(2)("initializing new Material.\n");
+  PRINTF(4)("initializing new Material.\n");
   this->nextMat = NULL;
   this->name ="";
@@ -112,17 +113,17 @@
 Material* Material::search(char* mtlName)
 {
-  PRINTF(2)("Searching for material %s", mtlName);
+  PRINTF(5)("Searching for material %s", mtlName);
   Material* searcher = this;
   while (searcher != NULL)
     {
-      PRINT(2)(".");
+      PRINT(5)(".");
       if (!strcmp (searcher->getName(), mtlName))
 	{
-	  PRINT(2)("found.\n");
+	  PRINT(5)("found.\n");
 	  return searcher;
 	}
       searcher = searcher->nextMat;
     }
-  PRINT(2)("not found\n");
+  PRINT(2)("material %s not found\n", mtlName);
   return NULL;
 }
@@ -171,5 +172,5 @@
 void Material::setName (char* mtlName)
 {
-  PRINTF(3)("setting Material Name to %s.\n", this->name);
+  PRINTF(4)("setting Material Name to %s.\n", this->name);
   this->name = new char [strlen(mtlName)+1];
   strcpy(this->name, mtlName);
@@ -190,7 +191,6 @@
 void Material::setIllum (int illum)
 {
-  PRINTF(3)("setting illumModel of Material %s to %i\n", this->name, illum);
+  PRINTF(4)("setting illumModel of Material %s to %i\n", this->name, illum);
   this->illumModel = illum;
-  //  PRINTF(3)("setting illumModel to: %i\n", illumModel);
 }
 /**
@@ -210,5 +210,5 @@
 void Material::setDiffuse (float r, float g, float b)
 {
-  PRINTF(3)("setting Diffuse Color of Material %s to r=%f g=%f b=%f.\n", this->name, r, g, b);
+  PRINTF(4)("setting Diffuse Color of Material %s to r=%f g=%f b=%f.\n", this->name, r, g, b);
   this->diffuse[0] = r;
   this->diffuse[1] = g;
@@ -236,5 +236,5 @@
 void Material::setAmbient (float r, float g, float b)
 {
-  PRINTF(3)("setting Ambient Color of Material %s to r=%f g=%f b=%f.\n", this->name, r, g, b);
+  PRINTF(4)("setting Ambient Color of Material %s to r=%f g=%f b=%f.\n", this->name, r, g, b);
   this->ambient[0] = r;
   this->ambient[1] = g;
@@ -261,5 +261,5 @@
 void Material::setSpecular (float r, float g, float b)
 {
-  PRINTF(3)("setting Specular Color of Material %s to r=%f g=%f b=%f.\n", this->name, r, g, b);
+  PRINTF(4)("setting Specular Color of Material %s to r=%f g=%f b=%f.\n", this->name, r, g, b);
   this->specular[0] = r;
   this->specular[1] = g;
@@ -301,5 +301,5 @@
 void Material::setTransparency (float trans)
 {
-  PRINTF(3)("setting Transparency of Material %s to %f.\n", this->name, trans);
+  PRINTF(4)("setting Transparency of Material %s to %f.\n", this->name, trans);
   this->transparency = trans;
 }
@@ -330,5 +330,5 @@
 void Material::setDiffuseMap(char* dMap)
 {
-  PRINTF(3)("setting Diffuse Map %s\n", dMap);
+  PRINTF(4)("setting Diffuse Map %s\n", dMap);
   diffuseTexture = new Texture();
   this->diffuseTextureSet = diffuseTexture->loadImage(dMap);
Index: /orxonox/trunk/src/lib/graphics/importer/model.cc
===================================================================
--- /orxonox/trunk/src/lib/graphics/importer/model.cc	(revision 3547)
+++ /orxonox/trunk/src/lib/graphics/importer/model.cc	(revision 3548)
@@ -80,14 +80,14 @@
 Model::~Model(void)
 {
-  PRINTF(3)("Deleting Model ");
+  PRINTF(4)("Deleting Model ");
   if (this->name)
     {
-      PRINT(3)("%s\n", this->name);
+      PRINT(4)("%s\n", this->name);
       delete []this->name;
     }
   else
-      PRINT(3)("\n");
-
-  PRINTF(3)("Deleting display Lists.\n");
+      PRINT(4)("\n");
+
+  PRINTF(4)("Deleting display Lists.\n");
   Group* walker = this->firstGroup;
   while (walker != NULL)
@@ -99,5 +99,5 @@
     }
 
-  PRINTF(3)("Deleting Materials.\n");
+  PRINTF(4)("Deleting Materials.\n");
   if (this->material)
     delete this->material;
@@ -122,9 +122,9 @@
 void Model::draw (void) const
 {
-  PRINTF(2)("drawing the 3D-Models\n"); 
+  PRINTF(4)("drawing the 3D-Models\n"); 
   Group* walker = this->firstGroup;
   while (walker != NULL)
     {
-      PRINTF(3)("Drawing model %s\n", walker->name);
+      PRINTF(5)("Drawing model %s\n", walker->name);
       glCallList (walker->listNumber);
       walker = walker->next;
@@ -142,8 +142,8 @@
   if (groupNumber >= this->groupCount)
     {
-      PRINTF(1)("You requested model number %i, but this File only contains of %i Models.\n", groupNumber-1, this->groupCount);
+      PRINTF(2)("You requested model number %i, but this File only contains of %i Models.\n", groupNumber-1, this->groupCount);
       return;
     }
-  PRINTF(2)("drawing the requested 3D-Models if found.\n"); 
+  PRINTF(4)("drawing the requested 3D-Models if found.\n"); 
   Group* walker = this->firstGroup;
   int counter = 0;
@@ -152,5 +152,5 @@
       if (counter == groupNumber)
 	{
-	  PRINTF(2)("Drawing model number %i named %s\n", counter, walker->name);
+	  PRINTF(4)("Drawing model number %i named %s\n", counter, walker->name);
 	  glCallList (walker->listNumber);
 	  return;
@@ -159,5 +159,5 @@
       walker = walker->next;
     }
-  PRINTF(1)("Model number %i in %s not Found.\n", groupNumber, this->name);
+  PRINTF(2)("Model number %i in %s not Found.\n", groupNumber, this->name);
   return;
 
@@ -172,5 +172,5 @@
 void Model::draw (char* groupName) const
 {
-  PRINTF(2)("drawing the requested 3D-Models if found.\n"); 
+  PRINTF(4)("drawing the requested 3D-Models if found.\n"); 
   Group* walker = this->firstGroup;
   while (walker != NULL)
@@ -178,5 +178,5 @@
       if (!strcmp(walker->name, groupName))
 	{
-	  PRINTF(2)("Drawing model %s\n", walker->name);
+	  PRINTF(4)("Drawing model %s\n", walker->name);
 	  glCallList (walker->listNumber);
 	  return;
@@ -184,5 +184,5 @@
       walker = walker->next;
     }
-  PRINTF(1)("Model Named %s in %s not Found.\n", groupName, this->name);
+  PRINTF(2)("Model Named %s in %s not Found.\n", groupName, this->name);
   return;
 }
@@ -204,5 +204,5 @@
 bool Model::initialize (void)
 {
-  PRINTF(2)("new 3D-Model is being created\n"); 
+  PRINTF(4)("new 3D-Model is being created\n"); 
 
   this->name = NULL;
@@ -243,5 +243,5 @@
 bool Model::initGroup(Group* group)
 {
-  PRINTF(3)("Adding new Group\n");
+  PRINTF(4)("Adding new Group\n");
   group->name = "";
   group->faceMode = -1;
@@ -277,5 +277,5 @@
 bool Model::cleanup(void)
 {
-  PRINTF(3)("cleaning up the 3D-Model to save Memory.\n");
+  PRINTF(4)("cleaning up the 3D-Model to save Memory.\n");
 
   if (this->vertices)
@@ -296,5 +296,5 @@
 bool Model::cleanupGroup (Group* group)
 {
-  PRINTF(3)("Cleaning up group\n");
+  PRINTF(5)("Cleaning up group\n");
   if (group->firstFace != NULL)
     {
@@ -314,5 +314,5 @@
 bool Model::cleanupFace (Face* face)
 {
-  PRINTF(3)("Cleaning up Face\n");
+  PRINTF(5)("Cleaning up Face\n");
 
   if (face->materialString != NULL)
@@ -355,5 +355,5 @@
 bool Model::addGroup (char* groupString)
 {
-  PRINTF(3)("Read Group: %s.\n", groupString);
+  PRINTF(5)("Read Group: %s.\n", groupString);
   if (this->groupCount != 0 && this->currentGroup->faceCount>0)
     {
@@ -384,5 +384,5 @@
   float subbuffer3;
   sscanf (vertexString, "%f %f %f", &subbuffer1, &subbuffer2, &subbuffer3);
-  PRINTF(3)("reading in a vertex: %f %f %f\n", &subbuffer1, &subbuffer2, &subbuffer3);
+  PRINTF(5)("reading in a vertex: %f %f %f\n", &subbuffer1, &subbuffer2, &subbuffer3);
   this->vertices->addEntry(subbuffer1*scaleFactor, subbuffer2*scaleFactor, subbuffer3*scaleFactor);
   return true;
@@ -398,5 +398,5 @@
 bool Model::addVertex(const float x, const float y, const float z)
 {
-  PRINTF(4)("reading in a vertex: %f %f %f\n", x, y, z);
+  PRINTF(5)("reading in a vertex: %f %f %f\n", x, y, z);
   this->vertices->addEntry(x*scaleFactor, y*scaleFactor, z*scaleFactor);
   return true;
@@ -513,5 +513,5 @@
   float subbuffer3;
   sscanf (normalString, "%f %f %f", &subbuffer1, &subbuffer2, &subbuffer3);
-  PRINTF(3)("found vertex-Normal %f, %f, %f\n", &subbuffer1,&subbuffer2,&subbuffer3);
+  PRINTF(5)("found vertex-Normal %f, %f, %f\n", &subbuffer1,&subbuffer2,&subbuffer3);
   this->normals->addEntry(subbuffer1, subbuffer2, subbuffer3);
   return true;
@@ -544,5 +544,5 @@
   float subbuffer2;
   sscanf (vTextureString, "%f %f", &subbuffer1, &subbuffer2);
-  PRINTF(3)("found vertex-Texture %f, %f\n", &subbuffer1, &subbuffer2);
+  PRINTF(5)("found vertex-Texture %f, %f\n", &subbuffer1, &subbuffer2);
   this->vTexture->addEntry(subbuffer1);
   this->vTexture->addEntry(subbuffer2);
@@ -610,5 +610,5 @@
       if ((this->currentGroup->listNumber = glGenLists(1)) == 0)
 	{
-	  PRINTF(1)("list could not be created for this Model\n");
+	  PRINTF(2)("glList could not be created for this Model\n");
 	  return false;
 	}
@@ -628,8 +628,8 @@
 		{
 		  tmpMat->select();
-		  PRINTF(2)("using material %s for coming Faces.\n", tmpFace->materialString);
+		  PRINTF(5)("using material %s for coming Faces.\n", tmpFace->materialString);
 		}
 	      else 
-		PRINTF(1)("material %s not found.\n", tmpFace->materialString);
+		PRINTF(2)("material %s not found.\n", tmpFace->materialString);
 
 
@@ -646,5 +646,5 @@
 	      
 	      this->currentGroup->faceMode = 3;
-	      PRINTF(3)("found triag.\n");
+	      PRINTF(5)("found triag.\n");
 	    }
 	  
@@ -658,5 +658,5 @@
 		}
 	      this->currentGroup->faceMode = 4;
-	      PRINTF(3)("found quad.\n");
+	      PRINTF(5)("found quad.\n");
 	    }
 	  
@@ -666,5 +666,5 @@
 		glEnd();
 	      glBegin(GL_POLYGON);
-	      PRINTF(3)("Polygon with %i faces found.", tmpFace->vertexCount);
+	      PRINTF(5)("Polygon with %i faces found.", tmpFace->vertexCount);
 	      this->currentGroup->faceMode = tmpFace->vertexCount;
 	    }
@@ -698,5 +698,5 @@
 bool Model::addGLElement (FaceElement* elem)
 {
-  PRINTF(3)("importing grafical Element to openGL.\n");
+  PRINTF(5)("importing grafical Element to openGL.\n");
 
   if (elem->texCoordNumber != -1)
@@ -721,5 +721,5 @@
 {
   
-  PRINTF(2)("Normals are being calculated.\n");
+  PRINTF(4)("Normals are being calculated.\n");
 
   Vector* normArray = new Vector [vertices->getCount()/3];
@@ -778,5 +778,5 @@
     {
       normArray[i].normalize();
-      PRINTF(3)("Found Normale number %d: (%f; %f, %f).\n", i, normArray[i].x, normArray[i].y, normArray[i].z);
+      PRINTF(5)("Found Normale number %d: (%f; %f, %f).\n", i, normArray[i].x, normArray[i].y, normArray[i].z);
       
       this->normals->addEntry(normArray[i].x, normArray[i].y, normArray[i].z);
@@ -881,5 +881,5 @@
 	//printf ("%f %f\n", vz, sin (vz));
 	if (i==0.0)
-		  printf("%f, %f\n", j/df*2.0*PI, cos(j/df*PI));
+	  PRINTF(0)("%f, %f\n", j/df*2.0*PI, cos(j/df*PI));
       }
     }
Index: /orxonox/trunk/src/lib/graphics/importer/objModel.cc
===================================================================
--- /orxonox/trunk/src/lib/graphics/importer/objModel.cc	(revision 3547)
+++ /orxonox/trunk/src/lib/graphics/importer/objModel.cc	(revision 3548)
@@ -86,5 +86,5 @@
 bool OBJModel::importFile (char* fileName)
 {
-  PRINTF(3)("preparing to read in file: %s\n", fileName);
+  PRINTF(4)("preparing to read in file: %s\n", fileName);
 
 
@@ -107,9 +107,8 @@
   strncpy(this->objPath, fileName, name-fileName);
   this->objPath[name-fileName] = '\0';
-  if (verbose>=2)
-    if (strlen(objPath)> 0)
-      PRINTF(0)("Resolved file %s to folder: %s.\n", name, objPath);
-    else
-      PRINTF(0)("Resolved file %s.\n", name);
+  if (strlen(objPath)> 0)
+    PRINTF(5)("Resolved file %s to folder: %s.\n", name, objPath);
+  else
+    PRINTF(5)("Resolved file %s.\n", name);
   
   this->setName(name);
@@ -144,10 +143,10 @@
       return false;
     }
-  PRINTF(2)("Reading from opened file %s\n", fileName);
+  PRINTF(4)("Reading from opened file %s\n", fileName);
   char Buffer[10000];
   while(!OBJ_FILE->eof())
     {
       OBJ_FILE->getline(Buffer, 10000);
-      PRINTF(3)("Read input line: %s\n", Buffer);
+      PRINTF(5)("Read input line: %s\n", Buffer);
       
 
@@ -192,6 +191,5 @@
       else if (!strncmp(Buffer, "s ", 2)) //! \todo smoothing groups have to be implemented
 	{
-	  if (verbose >= 2)
-	    PRINTF(2)("smoothing groups not supportet yet. line: %s\n", Buffer);
+	  PRINTF(3)("smoothing groups not supportet yet. line: %s\n", Buffer);
 	}
     }
@@ -221,10 +219,10 @@
   
 
-  PRINTF(3)("Opening mtlFile: %s\n", fileName);
+  PRINTF(4)("Opening mtlFile: %s\n", fileName);
 
   ifstream* MTL_FILE = new ifstream (fileName);
   if (MTL_FILE->fail())
     {
-      PRINTF(1)("unable to open file: %s\n", fileName);
+      PRINTF(2)("unable to open file: %s\n", fileName);
       MTL_FILE->close();
       delete []fileName;
@@ -237,5 +235,5 @@
     {
       MTL_FILE->getline(Buffer, 500);
-      PRINTF(4)("found line in mtlFile: %s\n", Buffer);
+      PRINTF(5)("found line in mtlFile: %s\n", Buffer);
       
 
Index: /orxonox/trunk/src/lib/graphics/importer/texture.cc
===================================================================
--- /orxonox/trunk/src/lib/graphics/importer/texture.cc	(revision 3547)
+++ /orxonox/trunk/src/lib/graphics/importer/texture.cc	(revision 3548)
@@ -87,5 +87,5 @@
   if (pName[0] == '\0')
     {
-      PRINTF(3)("not Adding empty Path to the List.\n");
+      PRINTF(2)("not Adding empty Path to the List.\n");
       return;
     }
@@ -99,5 +99,5 @@
       if (status.st_mode & S_IFDIR)
 	{
-	  PRINTF(2)("Adding Path %s to the PathList.\n", pName);
+	  PRINTF(4)("Adding Path %s to the PathList.\n", pName);
 	  PathList* tmpPathList = this;
 	  while (tmpPathList->next)
@@ -193,5 +193,5 @@
 bool Texture::loadTexToGL (Image* pImage)
 {
-  PRINTF(2)("Loading texture to OpenGL-Environment.\n");
+  PRINTF(4)("Loading texture to OpenGL-Environment.\n");
   glGenTextures(1, &this->texture);
   glBindTexture(GL_TEXTURE_2D, this->texture);
@@ -229,5 +229,4 @@
 	pImage->format = GL_RGBA;
 	  
-      PRINTF(0)("Bits Per Pixel: %d\n", pImage->bpp);
       if( !IMG_isPNG(SDL_RWFromFile(imgNameWithPath, "rb")) && !IMG_isJPG(SDL_RWFromFile(imgNameWithPath, "rb")))
 	for (int i=0;i<map->h * map->w *3;i+=3)
@@ -249,5 +248,5 @@
   else
     {
-      PRINTF(1)("Image not Found: %s\n", imgNameWithPath);
+      PRINTF(2)("Image not Found: %s\n", imgNameWithPath);
       return false;
     }
@@ -268,5 +267,5 @@
       if (!strncmp(imgNameWithPath+strlen(imgNameWithPath)-4, ".bmp", 4))
 	{
-	  PRINTF(3)("Requested bmp-image. Trying to Import.\n");
+	  PRINTF(4)("Requested bmp-image. Trying to Import.\n");
 	  return this->loadBMP(imgNameWithPath);
 	}
@@ -274,20 +273,20 @@
       else if (!strncmp(imgNameWithPath+strlen(imgNameWithPath)-4, ".jpg", 4) || !strncmp(imgNameWithPath+strlen(imgNameWithPath)-5, ".jpg", 5))
 	{
-	  PRINTF(3)("Requested jpeg-image. Trying to Import\n");
+	  PRINTF(4)("Requested jpeg-image. Trying to Import\n");
 	  return this->loadJPG(imgNameWithPath);
 	}
       else if (!strncmp(imgNameWithPath+strlen(imgNameWithPath)-4, ".tga", 4))
 	{
-	  PRINTF(3)("Requested tga-image. Trying to Import\n");
+	  PRINTF(4)("Requested tga-image. Trying to Import\n");
 	  return this->loadTGA(imgNameWithPath);
 	}
       else if (!strncmp(imgNameWithPath+strlen(imgNameWithPath)-4, ".png", 4))
 	{
-	  PRINTF(3)("Requested png-image. Trying to Import\n");
+	  PRINTF(4)("Requested png-image. Trying to Import\n");
 	  return this->loadPNG(imgNameWithPath);
 	}
       else
 	{
-	  PRINTF(1)("Requested Image was not recognized in its type. (Maybe a type-Cast-error.)\n FileName: %s", imgNameWithPath);
+	  PRINTF(2)("Requested Image was not recognized in its type. (Maybe a type-Cast-error.)\n FileName: %s", imgNameWithPath);
 	  return false;
 	}
@@ -295,5 +294,5 @@
   else
     {
-      PRINTF(1)("Image not Found: %s\n", imgNameWithPath);
+      PRINTF(2)("Image not Found: %s\n", imgNameWithPath);
       return false;
     }
@@ -316,5 +315,5 @@
   if ((file = fopen(bmpName, "rb"))==NULL)
     {
-      PRINTF(1)("File Not Found : %s\n",bmpName);
+      PRINTF(2)("File Not Found : %s\n",bmpName);
       return false;
     }
@@ -325,5 +324,5 @@
   if ((i = fread(&pImage->width, 4, 1, file)) != 1) 
     {
-      PRINTF(1)("Error reading width from %s.\n", bmpName);
+      PRINTF(2)("Error reading width from %s.\n", bmpName);
       return false;
     }
@@ -331,5 +330,5 @@
   if ((i = fread(&pImage->height, 4, 1, file)) != 1) 
     {
-      PRINTF(1)("Error reading height from %s.\n", bmpName);
+      PRINTF(2)("Error reading height from %s.\n", bmpName);
       return false;
     }
@@ -341,5 +340,5 @@
   if ((fread(&planes, 2, 1, file)) != 1) 
     {
-      PRINTF(1)("Error reading planes from %s.\n", bmpName);
+      PRINTF(2)("Error reading planes from %s.\n", bmpName);
       return false;
     }
@@ -353,10 +352,10 @@
   if ((i = fread(&bpp, 2, 1, file)) != 1) 
     {
-      PRINTF(1)("Error reading bpp from %s.\n", bmpName);
+      PRINTF(2)("Error reading bpp from %s.\n", bmpName);
       return false;
     }
   if (bpp != 24) 
     {
-      PRINTF(1)("Bpp from %s is not 24: %u\n", bmpName, bpp);
+      PRINTF(2)("Bpp from %s is not 24: %u\n", bmpName, bpp);
       return false;
     }
@@ -369,5 +368,5 @@
   if (pImage->data == NULL) 
     {
-      PRINTF(1)("Error allocating memory for color-corrected image data");
+      PRINTF(2)("Error allocating memory for color-corrected image data");
       return false;	
     }
@@ -375,5 +374,5 @@
   if ((i = fread(pImage->data, size, 1, file)) != 1) 
     {
-      PRINTF(1)("Error reading image data from %s.\n", bmpName);
+      PRINTF(2)("Error reading image data from %s.\n", bmpName);
       return false;
     }
@@ -418,5 +417,5 @@
     {
       // Display an error message saying the file was not found, then return NULL
-      PRINTF(1)("Unable to load JPG File %s.\n", jpgName);
+      PRINTF(2)("Unable to load JPG File %s.\n", jpgName);
       return false;
     }
@@ -521,5 +520,5 @@
   if(fTGA == NULL)
     {
-      PRINTF(1)("Error could not open texture file: %s\n", tgaName);
+      PRINTF(2)("Error could not open texture file: %s\n", tgaName);
       return false;
     }
@@ -527,5 +526,5 @@
   if(fread(&tgaHeader, sizeof(TGAHeader), 1, fTGA) == 0)
     {
-      PRINTF(1)("Error could not read file header of %s\n", tgaName);
+      PRINTF(2)("Error could not read file header of %s\n", tgaName);
       if(fTGA != NULL)
 	{
@@ -549,5 +548,5 @@
   else
     {
-      PRINTF(1)("Error TGA file be type 2 or type 10\n");
+      PRINTF(2)("Error TGA file be type 2 or type 10\n");
       if (fTGA)
 	fclose(fTGA);
@@ -576,5 +575,5 @@
   if(fread(header, sizeof(header), 1, fTGA) == 0)
     {
-      PRINTF(1)("Error could not read info header\n");
+      PRINTF(2)("Error could not read info header\n");
       return false;
     }
@@ -586,5 +585,5 @@
   if((pImage->width <= 0) || (pImage->height <= 0) || ((pImage->bpp != 24) && (pImage->bpp !=32)))
     {
-      PRINTF(1)("Error invalid texture information\n");
+      PRINTF(2)("Error invalid texture information\n");
       return false;
     }
@@ -605,5 +604,5 @@
   if(pImage->data == NULL)
     {
-      PRINTF(1)("Error could not allocate memory for image\n");
+      PRINTF(2)("Error could not allocate memory for image\n");
       return false;
     }
@@ -611,5 +610,5 @@
   if(fread(pImage->data, 1, imageSize, fTGA) != imageSize)
     {
-      PRINTF(1)("Error could not read image data\n");
+      PRINTF(2)("Error could not read image data\n");
       if(pImage->data != NULL)
 	{
@@ -648,5 +647,5 @@
   if(fread(header, sizeof(header), 1, fTGA) == 0)
     {
-      PRINTF(1)("Error could not read info header\n");
+      PRINTF(2)("Error could not read info header\n");
       return false;
     }
@@ -664,5 +663,5 @@
   if((pImage->width <= 0) || (pImage->height <= 0) || ((pImage->bpp != 24) && (pImage->bpp !=32)))
     {
-      PRINTF(1)("Error Invalid pImage information\n");
+      PRINTF(2)("Error Invalid pImage information\n");
       return false;
     }
@@ -674,5 +673,5 @@
   if(pImage->data == NULL)
     {
-      PRINTF(1)("Error could not allocate memory for image\n");
+      PRINTF(2)("Error could not allocate memory for image\n");
       return false;
     }
@@ -684,5 +683,5 @@
       if(fread(&chunkheader, sizeof(GLubyte), 1, fTGA) == 0)
 	{
-	  PRINTF(1)("Error could not read RLE header\n");
+	  PRINTF(2)("Error could not read RLE header\n");
 	  if(pImage->data != NULL)
 	    {
@@ -702,5 +701,5 @@
 	      if(fread(colorbuffer, 1, bytesPerPixel, fTGA) != bytesPerPixel)
 		{
-		  PRINTF(1)("Error could not read image data\n");
+		  PRINTF(2)("Error could not read image data\n");
 		  if(colorbuffer != NULL)
 		    {
@@ -732,5 +731,5 @@
 	      if(currentpixel > pixelcount)	
 		{
-		  PRINTF(1)("Error too many pixels read\n");
+		  PRINTF(2)("Error too many pixels read\n");
 		  if(colorbuffer != NULL)
 		    {
@@ -754,5 +753,5 @@
 	  if(fread(colorbuffer, 1, bytesPerPixel, fTGA) != bytesPerPixel) // Attempt to read following color values 
 	    {
-	      PRINTF(1)("Error could not read from file");
+	      PRINTF(2)("Error could not read from file");
 	      if(colorbuffer != NULL)
 		{
@@ -785,5 +784,5 @@
 	      if(currentpixel > pixelcount)
 		{
-		  PRINTF(1)("Error too many pixels read\n");
+		  PRINTF(2)("Error too many pixels read\n");
 		  if(colorbuffer != NULL)
 		    {
Index: /orxonox/trunk/src/lib/graphics/importer/texture.h
===================================================================
--- /orxonox/trunk/src/lib/graphics/importer/texture.h	(revision 3547)
+++ /orxonox/trunk/src/lib/graphics/importer/texture.h	(revision 3548)
@@ -10,5 +10,8 @@
 #define _TEXTURE_H
 
-#include "stdincl.h"
+#include "glincl.h"
+
+#include "debug.h"
+
 #ifdef HAVE_SDL_SDL_IMAGE_H
 #include <SDL/SDL_image.h>
Index: /orxonox/trunk/src/orxonox.cc
===================================================================
--- /orxonox/trunk/src/orxonox.cc	(revision 3547)
+++ /orxonox/trunk/src/orxonox.cc	(revision 3548)
@@ -31,5 +31,5 @@
 #include "game_loader.h"
 #include <string.h>
-int verbose = 2;
+int verbose = 3;
 
 using namespace std;
Index: /orxonox/trunk/src/story_entities/world.cc
===================================================================
--- /orxonox/trunk/src/story_entities/world.cc	(revision 3547)
+++ /orxonox/trunk/src/story_entities/world.cc	(revision 3548)
@@ -701,4 +701,6 @@
       // Draw
       this->display ();
+
+      (TrackNode::getInstance()->getAbsCoor() - localPlayer->getAbsCoor()).debug();
   
       for( int i = 0; i < 5000000; i++) {}